import ExtratoRepository from '../Repositories/ExtratoRepository.js'

const getStoreBalance = async function ({CDCONSUMIDOR, consDetails}) {
    return await ExtratoRepository.getAppBalance(consDetails, CDCONSUMIDOR)
}

const getExtract = async function ({CDCONSUMIDOR, consDetails, DTINI, DTFIM}) {
    const movimentations = await ExtratoRepository.getExtract(consDetails, CDCONSUMIDOR, DTINI, DTFIM)
    const debitMovimentations = movimentations.filter(mv => mv.MOVIMENTACAO < 0)
    const expenseAvarage = ((debitMovimentations.map(mv => mv.MOVIMENTACAO).reduce((total, val) => total + val, 0)) / debitMovimentations.length) * -1
    const idpaiList = movimentations.map(m => m.IDPAI)
    const extract = {}

    idpaiList.forEach(id => {
        const currPaiMov = movimentations.filter(m => m.IDPAI === id)
        const extractPai = []
        if (currPaiMov.length) {
            extractPai.push({
                label: 'SALDO_ANTERIOR',
                value: null,
                balance: movimentations[0].SALDANT
            })
    
            for (let i = 0; i < movimentations.length; i++) {
                const mov = movimentations[i]
                extractPai.push({
                    label: mov.DSMOVIMENTACAO,
                    value: mov.MOVIMENTACAO,
                    balance: mov?.SALDODISP
                })
            }
            
            extractPai.push({
                label: 'SALDO_ATUAL',
                value: '',
                balance: movimentations.at(-1)?.SALDODISP
            })
        }
        extract[id] = extractPai
    })

    return {extract, expenseAvarage}
}

const getFullBalance = async function ({consDetails}) {
    return await ExtratoRepository.getFullBalance(consDetails)
}

export default { getStoreBalance, getExtract, getFullBalance }
