import { createApp } from 'vue'
import App from './App.vue'
import './registerServiceWorker'
import router from './router'
import store from './store'
import VCalendar from 'v-calendar'
import Notifications from '@kyvg/vue3-notification'
import 'v-calendar/style.css'

// EventBus - For global events
import mitt from 'mitt'
const emitter = mitt()

const app = createApp(App)
app.config.globalProperties.emitter = emitter
app.use(VCalendar, {})
app.use(Notifications)
app.use(store).use(router).mount('#app')
